



var listOfChanges = new Array();
var nbOfElt = 0;
var global = new Array();
var flag = new Array();

function submitUpdates()
{
	if (confirmEstimatedTime(document.getElementById('Source11').value, "false") == false)
		return;
	
	document.getElementById('url').value=getUrl();
    if( nbOfElt != 0) 
	{
			document.UpdateProbe.elements[1].value=getEltChangedAsString();
	}
	

	document.UpdateProbe.submit();
	
	return true;
}

function getUrl() {
         arg = document.URL;
         pos = arg.indexOf("&reload=");
         
         if (pos != -1) page = arg.substring(0,pos);
         else page = arg;
        
         return page;
         
}

function refresh()
{
	if (confirmEstimatedTime(document.getElementById('Source11').value, "true") == false)
		return;
		
	document.UpdateProbe.action.value='refreshProbe';    	
	document.UpdateProbe.submit();
	
	return true;
}

function storeChanges(eltName, lv)
{
	if (!listOfChanges[eltName]) 
	{
		listOfChanges[eltName]=lv;
		nbOfElt++;
	 }

	 return true;
}

function getEltChangedAsString()
{
	var testKey;
	var listAsString = '';
	for ( testKey in listOfChanges ) 
	{
		if (listOfChanges[testKey]) 
		{ 
			listAsString += testKey+',';
		} 
	} 
	listAsString = listAsString.substring(0,listAsString.length-1); 
	
	return listAsString;
}

function changeAbooleanProperty(e)
{
	var elt;
	if(window.event) 
	{ 
		elt = window.event.srcElement;
	}
	else if (e) 
	{ 
		elt = e.target;
	}
	else  
	{
		return true;
	}

	changeAbooleanPropertyWithElt(elt);

	return true;
} 



function changeAbooleanPropertyWithElt(elt)
{
	if (elt) 
	{
		var v = elt.value; 
		if(elt.checked) 
		{ 
			elt.value='yes';
		}
		else  
		{
			elt.value='no';
		}

		storeChanges(elt.name,v);
	 } 

	 return true;
} 



function  checkAll(formId, pid, check )
{
	var cbid = pid+':globalCB';
	if (check == 1)
	{
		for (i=0,n=formId.elements.length;i<n;i++) 
		{
			if (formId.elements[i].name.indexOf(pid) == 0 && formId.elements[i].name.indexOf('globalCB') == -1 && formId.elements[i].name.indexOf(':H') == -1)
			 { 
				 var elt = formId.elements[i];
				 elt.checked = true;
				 changeAbooleanPropertyWithElt(elt);
			}
		}
		  
		document.getElementById(cbid).checked=true;
	}
	if (check == 0)
	{
		for (i=0,n=formId.elements.length;i<n;i++) 
		{
			if (formId.elements[i].name.indexOf(pid) == 0 && formId.elements[i].name.indexOf('globalCB') == -1 && formId.elements[i].name.indexOf(':H') == -1)
			 { 
				 var elt = formId.elements[i];
				 elt.checked = false;
				 changeAbooleanPropertyWithElt(elt);
			}
		}

		document.getElementById(cbid).checked=false;
	}
}


function  toggle( pid )
{
	var cbid = pid+':globalCB';
	if (document.getElementById(cbid).checked) 
	{
		global[pid] = 1;
	}
	else 
	{
		global[pid]=0;
	}

	checkAll(document.UpdateProbe,pid,global[pid]);
}


function  aToggle( pid )
{
	var cbid = pid+':globalCB';
	checkStatus(document.getElementById('UpdateProbe'),pid);
	if (flag[pid]==0) 
	{ 
		document.getElementById(cbid).checked=false;global[pid]=0;
	}
	else 
	{ 
		document.getElementById(cbid).checked=true;global[pid]=1;
	}
}


function  checkStatus(formId, pid )
{
	for (i=0,n=formId.elements.length;i<n;i++) 
	{
		if (formId.elements[i].name.indexOf(pid) == 0 && formId.elements[i].name.indexOf('globalCB') == -1 && formId.elements[i].name.indexOf(':H') == -1) 
		{
			if(formId.elements[i].checked==true)  
			{
				flag[pid]=1;
			}
			else 
			{ 
				flag[pid]=0;
				return;
			}
		}
	}
}


function confirmEstimatedTime(source, reload){
	var returnValue = true;
	var estimatedTime = parseInt(getEstimatedTime(source, reload));

	if (estimatedTime > 0){
		var w1 = document.getElementById('TimeEstimateWarning1').value;
		var w2 = document.getElementById('TimeEstimateWarning2').value;
		returnValue = confirm(w1 + " " + estimatedTime + " " + w2);
	}

	return returnValue;
}


// source is the element we're checking - usually the router's element id
// reload is either "true" or "false".  if set to "true" the estimated time is the 
// transaction time plus the time for a reload of that router
function getEstimatedTime(source, reload){
	var estimatedTime = 0;
	var xmlHttpReq = false;

	if (window.XMLHttpRequest) { // Mozilla, Safari,...
    		xmlHttpReq = new XMLHttpRequest();
		if (xmlHttpReq.overrideMimeType){
    			xmlHttpReq.overrideMimeType('text/xml');
		}
	
	} 
	else if (window.ActiveXObject){ // IE
		try { xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP"); } 
		catch (e){}
	}

	urlParts = document.location.href.split("?")[0].split("/");
	url = document.location.protocol + "//" + document.location.host + "/" + document.location.pathname + "../../DataView/DVProbeConfig";
	url = url.replace(urlParts[urlParts.length - 1], "") + "?action=estimateTransactionTime&Source=" + source + "&Reload=" + reload;

	xmlHttpReq.open("GET", url, false);
	xmlHttpReq.send(null);

	if(xmlHttpReq.status == 200){		
		response  = xmlHttpReq.responseXML.documentElement;

		// try getting the time using the document model
		if (response != null){
			estimatedTime = response.getElementsByTagName('estimatedTime')[0].firstChild.data;
		}

		// if that doesn't work, just parse the text for the value
		else{
			xmlParts = xmlHttpReq.responseText.split("estimatedTime");
			estimatedTime = xmlParts[1].replace("/","").replace("<","").replace(">","");
		}
	} 

	return estimatedTime;
}